{{ Output.spin }}

VAR

  long Stack[9]                 'Stack space for new cog
  byte  Cog                       'Hold ID of cog in use, if any
                              
PUB Start(Pin, Delay, Count): Success
{{Start new blinking process in a new cog; return TRUE if successful.}}

  Stop
  Success := (Cog := cognew(Toggle(Pin, Delay, Count), @Stack) +1)      'Toggle Pin Count times, Delay s each

PUB Stop
{{Stop toggling process, if any.}}
  if Cog
      cogstop(Cog~ -1)

PUB Active: YesNo
{{Return True if process is active, False if otherwise.}}

  YesNo := Cog >0      
PUB Toggle(Pin, Delay, Count)   'Method called Toggle
{{Toggle Pin Count times waitng Delay system clock cycles in between
  If Count = 0, toggle Pin forever.}}
  
  dira[Pin]~~              'Set I/O pin to output direction
  repeat                   'Repeat the following 
    !outa[Pin]             '  "!"=Toggle I/O pin
    waitcnt(Delay + cnt)   '  Wait for Delay cycles
  while Count := --Count #> -1  'While not 0 (make min -1)
  Cog~                          'Clear Cog ID variable 